/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.third.sinopharm;

import org.apache.dubbo.common.stream.StreamObserver;
import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public interface SinopharmService extends org.apache.dubbo.rpc.model.DubboStub {

    String JAVA_SERVICE_NAME = "com.ywt.gapi.third.sinopharm.SinopharmService";
    String SERVICE_NAME = "com.ywt.gapi.third.sinopharm.SinopharmService";

    com.ywt.gapi.third.sinopharm.DrugMatchingResponse drugMatching(com.ywt.gapi.third.sinopharm.DrugMatchingRequest request);

    default CompletableFuture<com.ywt.gapi.third.sinopharm.DrugMatchingResponse> drugMatchingAsync(com.ywt.gapi.third.sinopharm.DrugMatchingRequest request){
        return CompletableFuture.completedFuture(drugMatching(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void drugMatching(com.ywt.gapi.third.sinopharm.DrugMatchingRequest request, StreamObserver<com.ywt.gapi.third.sinopharm.DrugMatchingResponse> responseObserver){
        drugMatchingAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.sinopharm.ConfirmOrderResponse confirmOrder(com.ywt.gapi.third.sinopharm.ConfirmOrderRequest request);

    default CompletableFuture<com.ywt.gapi.third.sinopharm.ConfirmOrderResponse> confirmOrderAsync(com.ywt.gapi.third.sinopharm.ConfirmOrderRequest request){
        return CompletableFuture.completedFuture(confirmOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void confirmOrder(com.ywt.gapi.third.sinopharm.ConfirmOrderRequest request, StreamObserver<com.ywt.gapi.third.sinopharm.ConfirmOrderResponse> responseObserver){
        confirmOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.sinopharm.PushInvoiceResponse pushInvoice(com.ywt.gapi.third.sinopharm.PushInvoiceRequest request);

    default CompletableFuture<com.ywt.gapi.third.sinopharm.PushInvoiceResponse> pushInvoiceAsync(com.ywt.gapi.third.sinopharm.PushInvoiceRequest request){
        return CompletableFuture.completedFuture(pushInvoice(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void pushInvoice(com.ywt.gapi.third.sinopharm.PushInvoiceRequest request, StreamObserver<com.ywt.gapi.third.sinopharm.PushInvoiceResponse> responseObserver){
        pushInvoiceAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }

    com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIResponse confirmOpenHisAPIOrder(com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIRequest request);

    default CompletableFuture<com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIResponse> confirmOpenHisAPIOrderAsync(com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIRequest request){
        return CompletableFuture.completedFuture(confirmOpenHisAPIOrder(request));
    }

    /**
    * This server stream type unary method is <b>only</b> used for generated stub to support async unary method.
    * It will not be called if you are NOT using Dubbo3 generated triple stub and <b>DO NOT</b> implement this method.
    */
    default void confirmOpenHisAPIOrder(com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIRequest request, StreamObserver<com.ywt.gapi.third.sinopharm.ConfirmOrderOpenHisAPIResponse> responseObserver){
        confirmOpenHisAPIOrderAsync(request).whenComplete((r, t) -> {
            if (t != null) {
                responseObserver.onError(t);
            } else {
                responseObserver.onNext(r);
                responseObserver.onCompleted();
            }
        });
    }






}
